CREATE TABLE DEPT (
	DEPTNO INT PRIMARY KEY,
	DNAME VARCHAR(14),
	LOC VARCHAR(13),
	VERSIONNO INT,
	ACTIVE INT
);

CREATE TABLE DEPT2 (
	DEPTNO INT PRIMARY KEY,
	DNAME VARCHAR(14),
	ACTIVE INT
);

CREATE TABLE EMP (
	EMPNO INT PRIMARY KEY,
	ENAME VARCHAR(10),
	JOB VARCHAR(9),
	MGR INT,
	HIREDATE TIMESTAMP,
	SAL INT,
	COMM INT,
	DEPTNO INT,
	TSTAMP TIMESTAMP
);

CREATE TABLE EMP2 (
	EMPNO INT PRIMARY KEY,
	ENAME VARCHAR(10),
	DEPTNUM INT
);

CREATE TABLE EMP_NULLABLE (
	EMPNO INT PRIMARY KEY,
	ENAME VARCHAR(10),
	JOB VARCHAR(9),
	MGR INT,
	HIREDATE TIMESTAMP,
	SAL INT,
	COMM INT,
	DEPTNO INT,
	TSTAMP TIMESTAMP,
	NULLABLENEXTRESTDATE TIMESTAMP
);

CREATE TABLE GENERIC_NULLABLE (
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	DDATE TIMESTAMP,
	ENTITYNO INT
);

CREATE TABLE UNDER_SCORE (
	UNDER_SCORE_NO INT PRIMARY KEY,
	TABLE_NAME VARCHAR(50),
	"TABLE_NAME_" VARCHAR(50),
	"_TABLE_NAME" VARCHAR(50),
	"_TABLE_NAME_" VARCHAR(50)
);

CREATE TABLE IDTABLE (
	ID INTEGER PRIMARY KEY AUTOINCREMENT,
	ID_NAME VARCHAR(20)
);

CREATE TABLE BASICTYPE (
	ID DECIMAL (18, 0) PRIMARY KEY,
	BOOLTYPE DECIMAL (1, 0),
	BYTETYPE INT,
	SBYTETYPE INT,
	INT16TYPE INT,
	INT32TYPE INT,
	INT64TYPE BIGINT,
	SINGLETYPE FLOAT,
	DOUBLETYPE DOUBLE PRECISION,
	DECIMALTYPE DECIMAL (28, 0),
	STRINGTYPE VARCHAR (1024),
	DATETIMETYPE TIMESTAMP
);

INSERT INTO EMP VALUES (7369, 'SMITH',  'CLERK',	7902, '1980-12-17 00:00:00',  800, NULL, 20, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7499, 'ALLEN',  'SALESMAN',	7698, '1981-02-20 00:00:00', 1600,  300, 30, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7521, 'WARD',   'SALESMAN',	7698, '1981-02-22 00:00:00', 1250,  500, 30, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7566, 'JONES',  'MANAGER',	7839, '1981-04-02 00:00:00', 2975, NULL, 20, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7654, 'MARTIN', 'SALESMAN',	7698, '1981-09-28 00:00:00', 1250, 1400, 30, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7698, 'BLAKE',  'MANAGER',	7839, '1981-05-01 00:00:00', 2850, NULL, 30, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7782, 'CLARK',  'MANAGER',	7839, '1981-06-09 00:00:00', 2450, NULL, 10, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7788, 'SCOTT',  'ANALYST',	7566, '1982-12-09 00:00:00', 3000, NULL, 20, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7839, 'KING',   'PRESIDENT', NULL, '1981-11-17 00:00:00', 5000, NULL, 10, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7844, 'TURNER', 'SALESMAN',	7698, '1981-09-08 00:00:00', 1500,	 0, 30, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7876, 'ADAMS',  'CLERK',		7788, '1983-01-12 00:00:00', 1100, NULL, 20, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7900, 'JAMES',  'CLERK',		7698, '1981-12-03 00:00:00',  950, NULL, 30, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7902, 'FORD',   'ANALYST',	7566, '1981-12-03 00:00:00', 3000, NULL, 20, '2000-01-01 00:00:00');
INSERT INTO EMP VALUES (7934, 'MILLER', 'CLERK',		7782, '1982-01-23 00:00:00', 1300, NULL, 10, '2000-01-01 00:00:00');
INSERT INTO DEPT VALUES (10, 'ACCOUNTING', 'NEW YORK', 0, 1);
INSERT INTO DEPT VALUES (20, 'RESEARCH',   'DALLAS',   0, 1);
INSERT INTO DEPT VALUES (30, 'SALES',	  'CHICAGO',  0, 1);
INSERT INTO DEPT VALUES (40, 'OPERATIONS', 'BOSTON',   0, 1);
INSERT INTO EMP2 VALUES (7369, 'SMITH', 20);
INSERT INTO EMP2 VALUES (7499, 'ALLEN', 30);
INSERT INTO DEPT2 VALUES (20, 'RESEARCH', 1);
INSERT INTO DEPT2 VALUES (30, 'SALES', 0);
INSERT INTO BASICTYPE VALUES (
	1,
	0,
	255,
	-128,
	32767,
	2147483647,
	9223372036854775807,
	9.876543,
	9.87654321098765,
	9999999999999999999999999999,
	'|\`',
	'1980-12-17 12:34:56'
);
INSERT INTO BASICTYPE (
	id
) VALUES (
	3
);
INSERT INTO BASICTYPE VALUES (
	4,
	1,
	2,
	3,
	4,
	5,
	6,
	7,
	8,
	9,
	'10',
	NULL
);
